const std = @import("std");
const Stack = @import("stack.zig").Stack;

pub fn main() !void {
    var gpa = std.heap.GeneralPurposeAllocator(.{}){};
    const allocator = gpa.allocator();
    const Stacku8 = Stack(u8);

    var stack: Stacku8 = try Stacku8.init(allocator, 100);
    defer stack.deinit();

    try stack.push(10);
    try stack.push(20);
    try stack.push(30);
    try stack.push(40);
    try stack.push(50);
    try stack.push(60);

    std.debug.print("Stack length: {d}\n", .{stack.length});
    std.debug.print("Stack capacity: {d}\n", .{stack.capacity});

    var popped = stack.pop();
    std.debug.print("Stack len: {d}. Popped value: {d}\n", .{stack.length, popped.?});
    popped = stack.pop();
    std.debug.print("Stack len: {d}. Popped value: {d}\n", .{stack.length, popped.?});
    std.debug.print("Stack state: {any}\n", .{stack.items[0..stack.length]});
}
